
#include<msp430g2553.h>
#include<stdio.h>//õsprintf()
#include"lcd12864.h"
#include"delay.h"
#include"ds18b20.h"
#include"PID.h"//PID㷨

long  uint  t1,t2,t3;//¶ȱ
double temperature,temperature1,temperature2,temperature3;//¶ȱ
uint tem1,tem2,setpoint;//tem1,tem2ڲɼ¶ȵݴsetpoint趨¶ݴ
char  displaybuf[16];//ݣд12864
char qian,bai,ge,shi;//¶Сֱݴ
char flag=0;//־λڵ

void display_temperature(void);
void alarm(void);//
void init_key(void);//ʼж
void control_comperature(void);//¶Ⱥ
void change(uint temp1,uint temp2);
void get_temperature(void);
void keyscan(void);

void main(void)
{
	WDTCTL=WDTPW+WDTHOLD;//ع

	P1DIR|=BIT1+BIT7;//P1.7ӷP1.1Ӽ̵
	P1OUT|=BIT1+BIT7;//͵ƽ죬̵͵ƽͨ

	init_12864();//ʼlcd12864
	clear_12864();//
	init_ds18b20();//ʼ18b20
	init_key();//ʼж

	//PWM
	P1DIR |= 0x04;                            // P1.2  output
	P1SEL |= 0x04;                            // P1.2  TA1/2 options
	CCR0 = 1000;                             // PWM Periodb
	CCTL1 = OUTMOD_7;                         // CCR1 reset/set
	CCR1 = 0;                               // CCR1 PWM duty cycle
	TACTL = TASSEL_2 + MC_1;                  // SMCLK, up mode

	//¼ΪPID	㷨ʼ
	PIDInit ( &sPID ); // Initialize Structure
	// ֡΢ֲѡȡдĽ
	sPID.Proportion = 5.0;
	sPID.Integral = 4.0;
	sPID.Derivative =3.0;
	sPID.SetPoint = 50.0; // Set PID Setpoint

//	_EINT();//ж
	screen();

	while(1)
	{
		keyscan();
		get_temperature();
	}
}

void get_temperature(void)
{
	t1=read_temperature(1);
	temperature1=(float)t1*0.0625;

	t2=read_temperature(1);
	temperature2=(float)t2*0.0625;

	t3=read_temperature(1);
	temperature3=(float)t3*0.0625;

	temperature=(temperature1+temperature2+temperature3)/3;

	control_comperature();//

	tem1=(int)temperature;//ȡ¶
	tem2=(int)10000*(temperature-tem1);//ΪȡС¶
	change(tem1,tem2);
	write_12864string(3,2,displaybuf);
	setpoint=(int)sPID.SetPoint;
	sprintf(displaybuf, "%d.%d",setpoint,(int)(sPID.SetPoint*10)%10);
	write_12864string(3,3,displaybuf);
}

void change(uint temp1,uint temp2)
{
	qian=temp2/1000;//18b20ԶȡλС
	bai=temp2/100%10;
	shi=temp2%100/10;
	ge=temp2%10;

	if(qian==0)
	{
	  if(bai==0)
	  {
		  if(shi==0)
		  {
			  if(ge==0)
				  sprintf(displaybuf, "%d.0000  ",temp1);
			  else
				  sprintf(displaybuf, "%d.000%d  ",temp1,ge);
		  }
		  else
			  sprintf(displaybuf, "%d.00%d%d",temp1,shi,ge);
	  }
	  else
		  sprintf(displaybuf, "%d.0%d%d%d  ",temp1,bai,shi,ge);
	}
	else
	  sprintf(displaybuf, "%d.%d%d%d%d  ",temp1,qian,bai,shi,ge);//ӡ¶ֵ
}

void init_key(void)		//ʼж
{
	P1DIR&=~(BIT4+BIT3+BIT5+BIT6);
	P1OUT|=BIT4+BIT3+BIT5+BIT6;
	P1REN |=BIT4+BIT3+BIT5+BIT6;
//	P1IES |=BIT4+BIT3+BIT5+BIT6;//شж
//	P1IE |=BIT4+BIT3+BIT5+BIT6;//ж
}

void alarm(void)		//
{
	if(temperature>=sPID.SetPoint+1)	//ʹds18b20ʱʱҪϣжϸŶȡ¶ֵ⡣
	{
		P1OUT&=~BIT7;//
		delayms(100);
		P1OUT|=BIT7;
		delayms(10);
		P1OUT&=~BIT7;
	}
	if(temperature<sPID.SetPoint+1)
		P1OUT|=BIT7;//ط
}

void control_comperature(void)
{
	if(temperature<sPID.SetPoint-0.8)//ɼ¶С趨¶ƫһʱ̵ڳPWMռձΪ0
	{
		alarm();
		CCR1=0;
		P1OUT|=BIT1;
	}

	else if((temperature>=sPID.SetPoint-0.8)&&(temperature<=sPID.SetPoint))//ɼ¶Ⱥ趨¶ȵƫС1ʱ
	{																//жϲɼ¶ǴӸͽһֱ
		alarm();
		if(flag)														//Ǹ̵ͣ
		{
			CCR1=0;
			P1OUT|=BIT1;
			delayms(8000);
			flag=0;
		}
		else												//ߣ̵Ͽ
		{													//ȻͨPID㷨صֵ
			P1OUT&=~BIT1;
			unsigned int i;
			for(i=0;i<2;i++)
			{
				rIn = temperature;
				current_rOut = PIDCalc ( &sPID,rIn ); // Perform PID Interation
				rOut_f=current_rOut-last_rOut;
				last_rOut=current_rOut;//
			}

			actuator ( rOut_f ); //PID㷨ķֵϵͳ
		}

	}

	else if(temperature>=sPID.SetPoint)//¶ȴĿ¶ʱرм豸
	{
		flag=1;
		P1OUT&=~BIT1;
		CCR1=0;
		alarm();
	}
}

void keyscan(void)//ɨ
{
	uchar z;

	if((P1IN&BIT3)==0)
	{
		delayms(5);
		if((P1IN&BIT3)==0)
		{
			while((P1IN&BIT3)==0);
			z=1;
		}
	}

	if((P1IN&BIT4)==0)
	{
		delayms(5);
		if((P1IN&BIT4)==0)
		{
			while((P1IN&BIT4)==0);
			z=2;
		}
	}

	if((P1IN&BIT5)==0)
	{
		delayms(5);
		if((P1IN&BIT5)==0)
		{
			while((P1IN&BIT5)==0);
			z=3;
		}
	}

	if((P1IN&BIT6)==0)
	{
		delayms(5);
		if((P1IN&BIT6)==0)
		{
			while((P1IN&BIT6)==0);
			z=4;
		}
	}

	switch(z)
	{
	case 1:{
				sPID.SetPoint++;
			  }break;

	case 2:{
				sPID.SetPoint--;
			  }break;
	case 3:{
				sPID.SetPoint+=0.5;
			  }break;
	case 4:{
				sPID.SetPoint-=0.5;
			  }break;
	}
}
















