
#ifndef PID_H_
#define PID_H_

#include <string.h>             //Cmemsetͷļ

typedef struct PID
{
	float SetPoint;      // 趨ĿDesired value
	double Proportion;    // Proportional Const
	double Integral;      // ֳIntegral Const
	double Derivative;    // ΢ֳDerivative Const
	double LastError;     // Error[-1]

	double PrevError;    // Error[-2]
	double SumError;    // Sums of Errors
} PID;

PID sPID; // PID Control Structure
double rOut_f,current_rOut,last_rOut; // PID Response (Output)
double rIn; // PID Feedback (Input)
int rOut_z,rOut_x;

void PIDInit (PID *pp) ;
double PIDCalc( PID *pp, double NextPoint ) ;
/*====================================================================================================
PID㲿
=====================================================================================================*/
double PIDCalc( PID *pp, double NextPoint )
{
	double dError, Error;
	Error = pp->SetPoint - NextPoint;           // ƫ
	pp->SumError += Error;                   // 
	dError = Error - pp->LastError;             // ǰ΢
	pp->PrevError = pp->LastError;
	pp->LastError = Error;
	return (
				pp->Proportion * Error // 
				+ pp->Integral * pp->SumError // 
				+ pp->Derivative * dError// ΢
			);
}
/*====================================================================================================
Initialize PID Structure  PIDʼ
=====================================================================================================*/
void PIDInit (PID *pp)
{
	memset ( pp,0,sizeof(PID));
}

void actuator(double out) // Dummy Actuator Function
{
	
}

#endif
